/* For copyright information, see olden_v1.0/COPYRIGHT */
#ifndef TORONTO
#include <cm/cmmd.h>
#include <fcntl.h>
#endif

#ifdef TORONTO
extern int NumNodes,NDim;
#define chatting printf
#else
extern int __NumNodes,__NDim;
#endif

extern int flag;

#ifndef TORONTO
void filestuff()
{
  CMMD_fset_io_mode(stdout, CMMD_independent);
  fcntl(fileno(stdout), F_SETFL, O_APPEND);
  if (CMMD_self_address()) exit(0);
  __InitRegs(0);
}
#endif

int mylog(int num)
{
  int j=0,k=1;
  
  while(k<num) { k*=2; j++; }
  return j;
} 

int dealwithargs(int argc, char *argv[])
{
  int size;

  if (argc > 3)
    flag = atoi(argv[3]);
  else 
    flag = 0;
#ifdef TORONTO  
  if (argc > 2) 
    NumNodes = atoi(argv[2]);
  else 
    NumNodes = 4;
#else
  if (argc > 2) 
    __NumNodes = atoi(argv[2]);
  else 
    __NumNodes = 4;
#endif
  if (argc > 1)
    size = atoi(argv[1]);
  else
    size = 16;
#ifdef TORONTO
  NDim = mylog(NumNodes);
  chatting("Voronoi with %d size on %d procs of dim %d\n", size, NumNodes, NDim);
#else
  __NDim = mylog(__NumNodes);
  if (CMMD_self_address() == 0)
    chatting("Voronoi with %d size on %d procs of dim %d\n",
	     size, __NumNodes, __NDim);
#endif
  return size;
  
}

